#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "bgmdrv.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

unsigned char	BGMDRV_int = 0;

int BGMDRV_check( void )
{
	char	id1[16];
	char	id2[16];
	char	id3[16];

	memset( id1, 0, sizeof( id1 ));
	memset( id2, 0, sizeof( id2 ));
	memset( id3, 0, sizeof( id3 ));

	_readvect( 0x64, 1,     -8, id1 ); /* BGM.COM */
	_readvect( 0x64, 1, 0x0103, id2 ); /* BGMDRV.COM */
	_readvect( 0x68, 1, 0x0103, id3 ); /* BGMDRV.COM */

	if( memcmp( id2, "KIN_BGM ", 7 ) != 0 )
	{
		if( memcmp( id3, "KIN_BGM ", 7 ) != 0 )
		{
			if( memcmp( id1, "BGM ", 3 ) != 0 )
			{
				printf( MES[MES_DRVNOTFOUND], DRIVER_name );
				return 1;
			} else BGMDRV_int = 0x64;
		} else BGMDRV_int = 0x68;
	} else BGMDRV_int = 0x64;

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int BGMDRV_load( char *filename )
{
	if( GMPV4SP_load( filename, 0, 0, 1 ) == -1 ) return 1;

	return 0;
}

int BGMDRV_play( char *opt1, char *opt2 )
{
	GMPV4SP_address( &seg, &off, 0 );

	if( opt1 == NULL ) r.h.ah = 0x00;
	else if( strcmpi( opt1, OPT[OPT_FM] ) == 0 ) r.h.ah = 0x00;
	else if( strcmpi( opt1, OPT[OPT_MIDI] ) == 0 ) r.h.ah = 0x01;
	else if( strcmpi( opt1, OPT[OPT_DUAL] ) == 0 ) r.h.ah = 0x02;
	else r.h.ah = 0x00;

	/* Music : DS:DX */
	r.h.al = 0x00;
	sr.ds = seg;
	r.x.dx = off;

	int86x( BGMDRV_int, &r, &ro, &sr );

	return 0;
}

int BGMDRV_stop( void )
{
	r.x.ax = 0x0300;
	int86x( BGMDRV_int, &r, &ro, &sr );

	return 0;
}

int BGMDRV_fade( void )
{
	r.x.ax = 0x0400;
	int86x( BGMDRV_int, &r, &ro, &sr );

	return 0;
}
