#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <farstr.h>

#include "emi.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

char *EMI_neiro = "CM_NEIRO.DAT";
char *EMI_se    = "CM_SE.DAT";
char *EMI_lfo   = "CM_LFO.DAT";
char *EMI_viv   = "CM_VIV.DAT";
char *EMI_env   = "CM_ENV.DAT";

int EMI_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x70, 0, -8, id );

	if( memcmp( id, "EMI", 3 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int EMI_load( char *filename )
{
	unsigned char far	*p = NULL;

	r.h.ah = 0x02;
	int86x( 0x70, &r, &ro, &sr );
	p = MK_FP( ro.x.dx, ro.x.bx );

	/* neiro : DX:BX */
	if( _far_fileload( EMI_neiro, p ) == -1 ) return 1;

	/* se : DX:BX + 0x2000 */
	if( _far_fileload( EMI_se, p + 0x00002000 ) == -1 ) return 1;

	/* lfo : DX:BX + 0x2400 */
	if( _far_fileload( EMI_lfo, p + 0x00002400 ) == -1 ) return 1;

	/* viv : DX:BX + 0x2800 */
	if( _far_fileload( EMI_viv, p + 0x00002800 ) == -1 ) return 1;

	/* env : DX:BX + 0x2C00 */
	if( _far_fileload( EMI_env, p + 0x00002C00 ) == -1 ) return 1;

	/* Music : DX:AX */
	p = MK_FP( ro.x.dx, ro.x.ax );
	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int EMI_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x04;
	int86x( 0x70, &r, &ro, &sr );

	return 0;
}

int EMI_stop( void )
{
	GMPV4SP_address( &seg, &off, 0 );

	/* init */
	r.h.ah = 0x00;
	sr.es = seg;
	int86x( 0x70, &r, &ro, &sr );

	r.h.ah = 0x05;
	int86x( 0x70, &r, &ro, &sr );

	return 0;
}

int EMI_fade( void )
{
	r.h.ah = 0x06;
	r.h.al = 0x10;
	int86x( 0x70, &r, &ro, &sr );

	return 0;
}
