#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "fmx.h"
#include "..\common.h"
#include "..\extern.h"

int FMX_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x60, 0, -3, id );

	if( memcmp( id, "FMX", 3 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int FMX_load( char *filename )
{
	unsigned char far	*p = NULL;

	/* Music : DS:DX */
	r.h.ah = 0x06;
	int86x( 0x60, &r, &ro, &sr );
	p = MK_FP(( unsigned short )sr.ds, ( unsigned short )ro.x.dx );

	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int FMX_play( char *opt1, char *opt2 )
{
	if( opt1 == NULL ) r.h.ah = 0x00;
	else if( strcmpi( opt1, OPT[OPT_FM] ) == 0 ) r.h.ah = 0x00;
	else if( strcmpi( opt1, OPT[OPT_MIDI] ) == 0 ) r.h.ah = 0x0E;
	else if( strcmpi( opt1, OPT[OPT_BEEP] ) == 0 ) r.h.ah = 0x15;
	else r.h.ah = 0x00;

	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int FMX_stop( void )
{
	r.h.ah = 0x01;
	int86x( 0x60, &r, &ro, &sr );	/* FM */
	r.h.ah = 0x0F;
	int86x( 0x60, &r, &ro, &sr );	/* MIDI */
	r.h.ah = 0x16;
	int86x( 0x60, &r, &ro, &sr );	/* BEEP */

	return 0;
}

int FMX_fade( void )
{
	/* FM Only */
	r.h.ah = 0x02;
	r.h.al = 0x01;
	int86x( 0x60, &r, &ro, &sr );

	r.h.ah = 0x0F;
	int86x( 0x60, &r, &ro, &sr );	/* MIDI STOP */
	r.h.ah = 0x16;
	int86x( 0x60, &r, &ro, &sr );	/* BEEP STOP */

	return 0;
}
