#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "hhd.h"
#include "..\common.h"
#include "..\extern.h"

unsigned char	HHD_int;
unsigned char	HHD_type;

int HHD_check( void )
{
	char	id1[16];
	char	id2[16];

	memset( id1, 0, sizeof( id1 ));
	memset( id2, 0, sizeof( id2 ));

	_readvect( 0x60, 0, -0x10, id1 );
	_readvect( 0x62, 0, -8, id2 );

	if( memcmp( id1, "HHD", 3 ) != 0 )
	{
		if( memcmp( &id1[8], "HHD", 3 ) != 0 )
		{
			if( memcmp( id2, "HMM", 3 ) != 0 )
			{
				printf( MES[MES_DRVNOTFOUND], DRIVER_name );
				return 1;
			} else {
				HHD_int = 0x62;
				HHD_type = 0;
			}
		} else {
			HHD_int = 0x60;
			HHD_type = 0;
		}
	} else {
		HHD_int = 0x60;
		HHD_type = 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int HHD_load( char *filename )
{
	unsigned char far	*p = NULL;

	r.h.ah = 0x00;
	int86x( HHD_int, &r, &ro, &sr );
	if( HHD_type == 1 )
	{
		/* Music : DX:BX */
		p = MK_FP(( unsigned short )ro.x.dx, ( unsigned short )ro.x.bx );
	} else {
		/* Music : DS:DX */
		p = MK_FP(( unsigned short )sr.ds, ( unsigned short )ro.x.dx );
	}
	if( _far_fileload( filename, p ) == -1 ) return 1;

	return 0;
}

int HHD_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x01;
	int86x( HHD_int, &r, &ro, &sr );

	return 0;
}

int HHD_stop( void )
{
	r.h.ah = 0x02;
	int86x( HHD_int, &r, &ro, &sr );

	return 0;
}

int HHD_fade( void )
{
	r.h.ah = 0x08;
	r.h.al = 0x05;
	int86x( HHD_int, &r, &ro, &sr );

	return 0;
}
