#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "ibgm.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

int IBGM_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x52, 0, -4, id );

	if( memcmp( id, "IKE", 3 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int IBGM_load( char *filename )
{
	if( GMPV4SP_load( filename, 0, 0, 1 ) == -1 ) return 1;

	return 0;
}

int IBGM_play( char *opt1, char *opt2 )
{
	GMPV4SP_address( &seg, &off, 0 );

	if( opt1 == NULL ) r.h.al = 0x00;
	else if( strcmpi( opt1, OPT[OPT_FM] ) == 0 ) r.h.al = 0x00;
	else if( strcmpi( opt1, OPT[OPT_MIDI] ) == 0 ) r.h.al = 0x01;
	else r.h.al = 0x00;

	/* Music : DS:SI */
	r.h.ah = 0x02;
	sr.ds  = seg;
	r.x.si = off;
	int86x( 0x52, &r, &ro, &sr );

	return 0;
}

int IBGM_stop( void )
{
	r.h.ah = 0x00;
	r.h.al = 0x03;
	int86x( 0x52, &r, &ro, &sr );

	return 0;
}

int IBGM_fade( void )
{
	r.h.ah = 0x00;
	r.h.al = 0x04;
	int86x( 0x52, &r, &ro, &sr );

	return 0;
}
