#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "mmd3.h"
#include "..\common.h"
#include "..\extern.h"

long	MMD3_size = -1;
char	*MMD3_bin = "*.BIN";

int MMD3_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x48, 1, 0x0A, id );

	if( memcmp( id, "MMD", 3 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MMD3_load( char *filename )
{
	struct find_t		ft;
	unsigned char far	*p = NULL;

	if( _dos_findfirst( MMD3_bin, _A_NORMAL, &ft ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], MMD3_bin );
		return 1;
	}

	MMD3_size = _filesize( ft.name );
	if( MMD3_size == -1 ) return 1;

	p = _far_calloc( MMD3_size );
	if( p == NULL ) return 1;
	_far_fileload( ft.name, p );

	/* Tone : DX:BX */
	r.h.ah = 0x11;
	r.x.bx = FP_OFF( p );
	r.x.cx = ( unsigned short )MMD3_size;
	r.x.dx = FP_SEG( p );
	int86x( 0x48, &r, &ro, &sr );

	farfree( p );

	MMD3_size = _filesize( filename );
	if( MMD3_size == -1 ) return 1;

	p = _far_calloc( MMD3_size );
	if( p == NULL ) return 1;
	_far_fileload( filename, p );

	/* Music : DX:BX */
	r.h.ah = 0x10;
	r.x.bx = FP_OFF( p );
	r.x.cx = ( unsigned short )MMD3_size;
	r.x.dx = FP_SEG( p );
	int86x( 0x48, &r, &ro, &sr );

	farfree( p );

	return 0;
}

int MMD3_play( char *opt1, char *opt2 )
{
	r.h.ah = 0x01;
	int86x( 0x48, &r, &ro, &sr );

	return 0;
}

int MMD3_stop( void )
{
	r.x.ax = 0x0000;
	int86x( 0x48, &r, &ro, &sr );
	return 0;
}

int MMD3_fade( void )
{
	r.h.ah = 0x06;
	r.h.al = 0x08;
	int86x( 0x48, &r, &ro, &sr );

	return 0;
}
