#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "music41.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

char	*MUSIC41_dat = "FMSOUND.DAT";

int MUSIC41_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x41, 1, -8, id );

	if( memcmp( id, "MUSIC", 5 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MUSIC41_load( char *filename )
{
	unsigned short	seg;
	unsigned short	off;

	/* Tone(page0) */
	GMPV4SP_address( &seg, &off, 0 );
	if( GMPV4SP_load( MUSIC41_dat, 0, 0, 1 ) == -1 ) return 1;
	r.h.al = 0x00;
	r.x.bx = seg;
	r.x.cx = 0x00;
	int86x( 0x41, &r, &ro, &sr );

	/* Music(page1) */
	if( GMPV4SP_size( 1 ) == -1 ) return 1;
	GMPV4SP_address( &seg, &off, 1 );
	if( GMPV4SP_load( filename, 0, 1, 1 ) == -1 ) return 1;
	r.h.al = 0x01;
	r.x.bx = seg;
	r.x.cx = 0x00;
	int86x( 0x41, &r, &ro, &sr );

	return 0;
}

int MUSIC41_play( char *opt1, char *opt2 )
{
	return 0;
}

int MUSIC41_stop( void )
{
	r.h.al = 0x02;
	int86x( 0x41, &r, &ro, &sr );

	return 0;
}
