#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "music68.h"
#include "..\common.h"
#include "..\extern.h"

int MUSIC68_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x68, 0, -16, id );

	if( memcmp( id, "MUSIC", 5 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MUSIC68_load( char *filename )
{
	long				filesize;
	unsigned char far	*p = NULL;

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	p = _far_calloc( filesize );
	_far_fileload( filename, p );

	/* Music DS:SI */
	r.h.al = 0x01;
	sr.ds  = FP_SEG( p );
	r.x.si = FP_OFF( p );
	int86x( 0x68, &r, &ro, &sr );

	farfree( p );

	return 0;
}

int MUSIC68_play( char *opt1, char *opt2 )
{
	return 0;
}

int MUSIC68_stop( void )
{
	r.h.al = 0x02;
	int86x( 0x68, &r, &ro, &sr );

	return 0;
}

int MUSIC68_fade( void )
{
	r.h.al = 0x02;
	int86x( 0x68, &r, &ro, &sr );

	return 0;
}
