#include <stdio.h>
#include <dos.h>
#include <memory.h>

#include "music70.h"
#include "..\common.h"
#include "..\extern.h"

int MUSIC70_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0x70, 0, 0, id );

	if( memcmp( id, "SQRWV", 5 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int MUSIC70_load( char *filename )
{
	long				filesize;
	unsigned char far	*p = NULL;

	filesize = _filesize( filename );
	if( filesize == -1 ) return 1;

	p = _far_calloc( filesize );
	_far_fileload( filename, p );

	/* Music : DS:DX */
	r.h.ah = 0x0A;
	sr.ds  = FP_SEG( p );
	r.x.dx = FP_OFF( p );
	int86x( 0x70, &r, &ro, &sr );

	farfree( p );

	return 0;
}

int MUSIC70_play( char *opt1, char *opt2 )
{
	return 0;
}

int MUSIC70_stop( void )
{
	r.h.ah = 0x01;
	int86x( 0x70, &r, &ro, &sr );

	return 0;
}

int MUSIC70_fade( void )
{
	r.h.ah = 0x02;
	r.h.al = 0x18;
	int86x( 0x70, &r, &ro, &sr );

	return 0;
}
