#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <farstr.h>

#include "naru.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

int NARU_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x70, 0, -9, id );

	if( memcmp( id, "NARU", 3 ) != 0 )
	{
		if( memcmp( id, "SARI", 3 ) != 0 )
		{
			printf( MES[MES_DRVNOTFOUND], DRIVER_name );
			return 1;
		}
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int NARU_load( char *filename )
{
	if( GMPV4SP_load( filename, 0, 0, 1 ) == -1 ) return 1;

	return 0;
}

int NARU_play( char *opt1, char *opt2 )
{
	GMPV4SP_address( &seg, &off, 0 );

	/* Music : DX:SI */
	r.x.dx = seg;
	r.x.si = off;

	r.h.ah = 0x00;
	int86x( 0x70, &r, &ro, &sr );

	r.h.ah = 0x06;
	int86x( 0x70, &r, &ro, &sr );

	r.h.ah = 0x01;
	int86x( 0x70, &r, &ro, &sr );

	return 0;
}

int NARU_stop( void )
{
	r.h.ah = 0x02;
	int86x( 0x70, &r, &ro, &sr );

	return 0;
}

int NARU_fade( void )
{
	r.h.ah = 0x03;
	int86x( 0x70, &r, &ro, &sr );

	return 0;
}
