#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "pmd.h"
#include "..\common.h"
#include "..\extern.h"

int	PMD_mode = 0;

int PMD_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));
	_readvect( 0x60, 0, 2, id );

	if( memcmp( id, "PMD", 3 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int PMD_load( char *filename )
{
	if( strcmpi( filename, OPT[OPT_MUSIC] ) == 0 )
	{
		PMD_mode = 0;
	} else if( strcmpi( filename, OPT[OPT_SE] ) == 0 )
	{
		PMD_mode = 1;
	} else return 1;

	return 0;
}

int PMD_play( char *opt1, char *opt2 )
{
	unsigned char far	*p = NULL;

	if( opt1 != NULL )
	{
		switch( PMD_mode )
		{
			case 0:
				/* Music DS:DX */
				r.h.ah = 0x06;
				break;
			case 1:
				/* SE(EFC) DS:DX */
				r.h.ah = 0x0B;
				break;
			default: return 1;
		}

		int86x( 0x60, &r, &ro, &sr );
		p = MK_FP(( unsigned short )sr.ds, ( unsigned short )ro.x.dx );

		if( _far_fileload( opt1, p ) == -1 ) return 1;

		if( strcmpi( opt2, OPT[OPT_SELECTOR] ) == 0 )
		{
			PMD_selector();
			return 0;
		}
	}

	switch( PMD_mode )
	{
		case 0:
			/* Music */
			r.h.ah = 0x00;
			break;
		case 1:
			/* SE(EFC) */
			r.h.ah = 0x0C;
			if( opt2 == NULL ) r.h.al = 0x00;
			else r.h.al = atoi( opt2 );
			printf( INFO[INFO_NO], r.h.al );
			break;
		default: return 1;
	}

	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int PMD_stop( void )
{
	r.h.ah = 0x01;
	int86x( 0x60, &r, &ro, &sr );

	r.h.ah = 0x0D;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int PMD_fade( void )
{
	r.h.ah = 0x02;
	r.h.al = 0x08;
	int86x( 0x60, &r, &ro, &sr );

	return 0;
}

int PMD_selector( void )
{
	int		no;
	char	buf[3];

	no = 0;

	for( ;; )
	{
		switch( getch())
		{
			case 0x0A:	/* DOWN */
				if( no > 0 ) no--;
				printf( INFO[INFO_NO], no );
				break;
			case 0x0B:	/* UP */
				if( no < 255 ) no++;
				printf( INFO[INFO_NO], no );
				break;
			case 0x0D:	/* ENTER */
				sprintf( buf, "%d", no );
				PMD_stop();
				PMD_play( NULL, buf );
				break;
			case 0x1B:	/* ESC */
				return 0;
			default: break;
		}
	}
}
