#include <stdio.h>
#include <dos.h>
#include <memory.h>
#include <fcntl.h>

#include "ufmd.h"
#include "..\common.h"
#include "..\extern.h"
#include "..\gmpv4sp.h"

int UFMD_check( void )
{
	char	id[16];

	memset( id, 0, sizeof( id ));

	_readvect( 0xF1, 0, 2, id );

	if( memcmp( id, "UFMD", 4 ) != 0 )
	{
		printf( MES[MES_DRVNOTFOUND], DRIVER_name );
		return 1;
	}

	printf( INFO[INFO_DRIVER], DRIVER_name );

	return 0;
}

int UFMD_load( char *filename )
{
	if( GMPV4SP_load( filename, 0, 0, 1 ) == -1 ) return 1;

	GMPV4SP_address( &seg, &off, 0 );

	/* Music : ES:DX */
	r.h.ah = 0x04;
	sr.es  = seg;
	r.x.dx = off;
	int86x( 0xF1, &r, &ro, &sr );

	return 0;
}

int UFMD_play( char *opt1, char *opt2 )
{
	/* Init fadeout */
	r.h.ah = 0x06;
	r.h.dh = 0x00;
	r.h.dl = 0x02;
	int86x( 0xF1, &r, &ro, &sr );

	/* Play */
	r.h.ah = 0x01;
	int86x( 0xF1, &r, &ro, &sr );

	return 0;
}

int UFMD_stop( void )
{
	r.h.ah = 0x02;
	int86x( 0xF1, &r, &ro, &sr );

	return 0;
}

int UFMD_fade( void )
{
	r.h.ah = 0x06;
	r.h.dh = 0x02;
	r.h.dl = 0x32;
	int86x( 0xF1, &r, &ro, &sr );

	return 0;
}
